=== debian/changelog ===
mimic (0.6.3+ds-1) unstable; urgency=medium

  * New upstream release
  * Add libxdp as suggested dependency through dlopen ELF metadata

 -- Eric Long <i@hack3r.moe>  Thu, 16 Jan 2025 13:50:08 +0800

mimic (0.6.2+ds-1) unstable; urgency=medium

  * Initial release (Closes: #1087937)

 -- Eric Long <i@hack3r.moe>  Sun, 24 Nov 2024 00:02:42 +0800
