=== debian/control ===
Source: mimic
Section: net
Priority: optional
Maintainer: Eric Long <i@hack3r.moe>
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-dkms,
 dh-sequence-dlopenlibdeps,
 dh-exec,
 clang,
 python3,
 bpftool,
 ronn,
 libbpf-dev,
 libffi-dev,
 libxdp-dev,
 linux-source,
 linux-headers-generic
Standards-Version: 4.7.0
Homepage: https://github.com/hack3ric/mimic
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/hacker/mimic
Vcs-Git: https://salsa.debian.org/hacker/mimic.git

Package: mimic
Architecture: amd64 arm64 powerpc ppc64 ppc64el riscv64
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 mimic-modules (= ${binary:Version})
Recommends: ${dlopen:Recommends}
Suggests: ${dlopen:Suggests}
Description: eBPF UDP -> TCP obfuscator
 Mimic is an experimental UDP to TCP obfuscator designed to bypass UDP
 QoS and port blocking. Based on eBPF, it directly mangles data inside
 Traffic Control (TC) subsystem in the kernel space and restores data
 using XDP, achieving remarkably high performance compared to other
 projects, such as udp2raw or Phantun.
 .
 This package contains the Mimic CLI and eBPF packet handler.

Package: mimic-dkms
Section: kernel
Architecture: amd64 arm64 powerpc ppc64 ppc64el riscv64
Provides: mimic-modules (= ${binary:Version})
Conflicts: mimic-modules
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 binutils,
 pahole
Recommends:
 xz-utils,
 bzip2,
 lzma,
 lzop,
 lz4,
 zstd
Description: eBPF UDP -> TCP obfuscator (DKMS kernel module)
 Mimic is an experimental UDP to TCP obfuscator designed to bypass UDP
 QoS and port blocking. Based on eBPF, it directly mangles data inside
 Traffic Control (TC) subsystem in the kernel space and restores data
 using XDP, achieving remarkably high performance compared to other
 projects, such as udp2raw or Phantun.
 .
 This package uses DKMS to automatically build kernel module against
 current kernel.
