## mimic 0.7.0+ds

=== Makefile ===
--- 
+++ 
@@ -127,6 +127,11 @@
 # compatibility, but also makes the program lose CO-RE functionality.
 STRIP_BTF_EXT ?=
 
+ifneq ($(COMPAT_LINUX_6_1),)
+CFLAGS += -DMIMIC_COMPAT_LINUX_6_1
+BPF_CFLAGS += -DMIMIC_COMPAT_LINUX_6_1
+endif
+
 # Rules
 
 mkdir_p = mkdir -p $(@D)
@@ -170,6 +175,7 @@
 	find . -type f -name *.o -delete
 	rm -f src/bpf_skel.h
 	rm -f bpf/vmlinux/system.h
+	rm -f kmod/dkms.conf kmod/AKMBUILD
 
 out/.options.%:
 	$(mkdir_p)
