=== debian/changelog ===
mimic (0.7.0+ds-2) unstable; urgency=medium

  * Add ppc64el and s390x to Architecture
  * mimic-dkms: move build hack dependencies to Recommends
  * Fix patch tags

 -- Eric Long <i@hack3r.moe>  Fri, 14 Mar 2025 13:18:17 +0800

mimic (0.7.0+ds-1) unstable; urgency=medium

  [ Eric Long ]
  * New upstream release.
  * Add autopkgtest integration-tests
  * Remove untested PowerPCs from Architecture
  * Use dh_installsysusers to fix piuparts
  * mimic-dkms: promote lz4 and xz-utils to Depends as they are used in
    official kernel (Closes: #1095728)
  * mimic-dkms: use bubblewrap for overlaying additional files on top of kernel
    module build directory (Closes: #1095722)
  * mimic-dkms: specify BUILD_EXCLUSIVE_KERNEL_MIN="6.1" and
    BUILD_EXCLUSIVE_CONFIG="CONFIG_DEBUG_INFO_BTF_MODULES"

  [ Andreas Beckmann ]
  * Declare Testsuite: autopkgtest-pkg-dkms.

 -- Eric Long <i@hack3r.moe>  Fri, 07 Mar 2025 17:52:17 +0800
