=== debian/control ===
--- 
+++ 
@@ -6,6 +6,7 @@
  debhelper-compat (= 13),
  dh-sequence-dkms,
  dh-sequence-dlopenlibdeps,
+ dh-sequence-installsysusers,
  dh-exec,
  clang,
  python3,
@@ -15,15 +16,15 @@
  libffi-dev,
  libxdp-dev,
  linux-source,
- linux-headers-generic
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/hack3ric/mimic
 Rules-Requires-Root: no
+Vcs-Git: https://salsa.debian.org/hacker/mimic.git
 Vcs-Browser: https://salsa.debian.org/hacker/mimic
-Vcs-Git: https://salsa.debian.org/hacker/mimic.git
+Testsuite: autopkgtest-pkg-dkms
 
 Package: mimic
-Architecture: amd64 arm64 powerpc ppc64 ppc64el riscv64
+Architecture: amd64 arm64 riscv64 ppc64el s390x
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
@@ -41,21 +42,21 @@
 
 Package: mimic-dkms
 Section: kernel
-Architecture: amd64 arm64 powerpc ppc64 ppc64el riscv64
+Architecture: amd64 arm64 riscv64 ppc64el s390x
 Provides: mimic-modules (= ${binary:Version})
 Conflicts: mimic-modules
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
- binutils,
- pahole
 Recommends:
+ pahole,
+ bubblewrap,
  xz-utils,
+ lz4,
+ zstd,
  bzip2,
  lzma,
  lzop,
- lz4,
- zstd
 Description: eBPF UDP -> TCP obfuscator (DKMS kernel module)
  Mimic is an experimental UDP to TCP obfuscator designed to bypass UDP
  QoS and port blocking. Based on eBPF, it directly mangles data inside
@@ -65,3 +66,9 @@
  .
  This package uses DKMS to automatically build kernel module against
  current kernel.
+ .
+ Mimic works out-of-the-box with Debian kernel shipped in trixie (and
+ versions above) without mimic-dkms' Recommends. Older or third-party
+ kernels are supported with best effort and with Recommends, but your
+ milage may vary. Linux version less than (exclusive) 6.1 and s390x
+ with non-official kernels are not supported at all.
