=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_VERSION_UPSTREAM

IS_UBUNTU := $(shell dpkg-vendor --derives-from ubuntu > /dev/null 2>&1; echo $$?)

njobs = 1
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
njobs = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

%:
	dh $@

override_dh_auto_configure:
	sed install/mimic@.service.in \
		-e 's|@@MIMIC_EXEC@@|/usr/sbin/mimic|' \
		-e 's|@@MIMIC_CONFIG_PATH@@|/etc/mimic|' \
		-e 's|@@MIMIC_RUNTIME_DIR@@|mimic|' \
		> debian/mimic@.service
	sed kmod/dkms.conf.in \
		-e 's|@@EXTRA_OPTS@@|CHECKSUM_HACK=kfunc|' \
		> kmod/dkms.conf
	cp install/mimic.sysusers debian/mimic.sysusers

override_dh_auto_build:
	tar xf `bash -c '_tarballs=(/usr/src/linux-source-*.tar.*); echo $${_tarballs[0]}'`
ifeq ($(IS_UBUNTU),0)
#	Ubuntu's bpftool relies on current kernel, which is both inconsistent
#	with Debian and sbuild-unfriendly. Build from kernel source instead.
	make -j$(njobs) -C linux-source-*/tools/bpf/bpftool
	dh_auto_build -- build-cli build-tools generate-manpage \
		MODE= \
		BPF_CC=clang \
		USE_LIBXDP=1 \
		BPFTOOL=linux-source-*/tools/bpf/bpftool/bpftool
else
	dh_auto_build -- build-cli build-tools generate-manpage \
		MODE= \
		BPF_CC=clang \
		USE_LIBXDP=1
endif
	make -j$(njobs) -C linux-source-*/tools/bpf/resolve_btfids

override_dh_auto_test:

override_dh_dkms:
	dh_dkms -pmimic-dkms -V$(DEB_VERSION_UPSTREAM)

override_dh_auto_clean:
	dh_auto_clean
	rm -rf linux-source-*
	rm -f debian/mimic@.service debian/mimic.sysusers
